//Variables to hold the image file name of the pieces
var x = "x.jpg";
var o = "o.jpg";
var blank = "blank.jpg";

//variables to hold which player is in which piece
var a = 0;
var b = 0;
var c = 0;
var d = 0;
var e = 0;
var f = 0;
var g = 0;
var h = 0;
var i = 0;
//x is player 1 (human)
//o is player 2 (computer)

var winner = 0;

var numberOfPeicesLeft = 9;

var myturn = true;

var gameover = false;
var gameInProgress = false;

var temp = "";


function setupApplication() 
{    
	setupGame();
    document.body.style.height = screen.height + 'px';

    blackberry.system.event.onHardwareKey(blackberry.system.event.KEY_BACK, function () 
    {
        blackberry.app.exit();			//Exit the application    	
    });
    setupMenuItems();
}

function setupMenuItems()
{
    var item1;
    var item2;

    // Channel/Session menu items
    item1 = new blackberry.ui.menu.MenuItem(false, 0, "Reset Game", reset);
    blackberry.ui.menu.addMenuItem(item1);
    item2 = new blackberry.ui.menu.MenuItem(false, 0, "Start Game", startGame);
    blackberry.ui.menu.addMenuItem(item2);
}

function setupGame()
{
	reset();
}

function clearAndReset()
{
	reset();
	startGame();
}

function reset()
{
	numberOfPeicesLeft = 9;
	a = 0;
	b = 0;
	c = 0;
	d = 0;
	e = 0;
	f = 0;
	g = 0;
	h = 0;
	i = 0;
	resetPieces();
	gameover = false;
	gameInProgress = false;
	myturn = true;
	winner = 0;
	document.getElementById("infomessages").innerHTML = "Press start to attempt to beat the computer at Tic Tac Toe!";
}

function resetPieces()
{
	document.images['A'].src = blank;
	document.images['B'].src = blank;
	document.images['C'].src = blank;
	document.images['D'].src = blank;
	document.images['E'].src = blank;
	document.images['F'].src = blank;
	document.images['G'].src = blank;
	document.images['H'].src = blank;
	document.images['I'].src = blank;
}

function startGame()
{
	gameover = false;
	gameInProgress = true;
	myturn = true;
	var infoMessage = document.getElementById('infomessages');
	infoMessage.innerHTML = "The game has started, please make your move.";
}


function makeMove(piece)
{
	if(gameInProgress==false)
	{
		alert("There is no game in progress, please press the start game button to start the game");
		return;
	}
	if(gameover==true)
	{
		alert("The current game is over, please reset to play again");
		return;
	}
	if(numberOfPeicesLeft==0)
	{
		alert("Game has finished, no more pieces to play.");
		return;
	}
	if(checkSpace(piece)==false)
	{
		alert("Invalid move, piece has already been played.");
		return;
	}
	if(myturn)
	{
		markPieceTaken(piece);
		document.images[piece].src = x;
		myturn = false;
		numberOfPeicesLeft--;
	}

	checkWinner();
	if(winner!=0)
	{
		alertWinner();
	}
	else
	{
		makeRandomMove();
	}
}

function makeRandomMove()
{
	var moveLetter = thinkAndMakeMove();
	markPieceTaken(moveLetter);
	document.images[moveLetter].src = o;
	
	checkWinner();
	if(winner!=0)
	{
		alertWinner();
	}
	else
	{
		myturn = true;
		numberOfPeicesLeft--;
	}
}

function thinkAndMakeMove()
{
	temp = "";
	logicOne();
	logicTwo();
	logicThree();
	return temp;
}

function logicOne() 
{
	if ((a==2)&&(b==2)&&(c== 0)&&(temp=="")) temp="C";
	if ((a==2)&&(b== 0)&&(c==2)&&(temp=="")) temp="B";
	if ((a== 0)&&(b==2)&&(c==2)&&(temp=="")) temp="A";
	if ((a==2)&&(d==2)&&(g== 0)&&(temp=="")) temp="G";
	if ((a==2)&&(d== 0)&&(g==2)&&(temp=="")) temp="D";
	if ((a== 0)&&(d==2)&&(g==2)&&(temp=="")) temp="A";
	if ((a==2)&&(e==2)&&(i== 0)&&(temp=="")) temp="I";
	if ((a==2)&&(e== 0)&&(i==2)&&(temp=="")) temp="E";
	if ((a== 0)&&(e==2)&&(i==2)&&(temp=="")) temp="A";
	if ((b==2)&&(e==2)&&(h== 0)&&(temp=="")) temp="H";
	if ((b==2)&&(e== 0)&&(h==2)&&(temp=="")) temp="E";
	if ((b== 0)&&(e==2)&&(h==2)&&(temp=="")) temp="B";
	if ((d==2)&&(e==2)&&(f== 0)&&(temp=="")) temp="F";
	if ((d==2)&&(e== 0)&&(f==2)&&(temp=="")) temp="E";
	if ((d== 0)&&(e==2)&&(f==2)&&(temp=="")) temp="D";
	if ((g==2)&&(h==2)&&(i== 0)&&(temp=="")) temp="I";
	if ((g==2)&&(h== 0)&&(i==2)&&(temp=="")) temp="H";
	if ((g== 0)&&(h==2)&&(i==2)&&(temp=="")) temp="G";
	if ((c==2)&&(f==2)&&(i== 0)&&(temp=="")) temp="I";
	if ((c==2)&&(f== 0)&&(i==2)&&(temp=="")) temp="F";
	if ((c== 0)&&(f==2)&&(i==2)&&(temp=="")) temp="C";
	if ((g==2)&&(e==2)&&(c== 0)&&(temp=="")) temp="C";
	if ((g==2)&&(e== 0)&&(c==2)&&(temp=="")) temp="E";
	if ((g== 0)&&(e==2)&&(c==2)&&(temp=="")) temp="G";
}
function logicTwo() 
{
	if ((a==1)&&(b==1)&&(c==0)&&(temp=="")) temp="C";
	if ((a==1)&&(b==0)&&(c==1)&&(temp=="")) temp="B";
	if ((a==0)&&(b==1)&&(c==1)&&(temp=="")) temp="A";
	if ((a==1)&&(d==1)&&(g==0)&&(temp=="")) temp="G";
	if ((a==1)&&(d==0)&&(g==1)&&(temp=="")) temp="D";
	if ((a==0)&&(d==1)&&(g==1)&&(temp=="")) temp="A";
	if ((a==1)&&(e==1)&&(i==0)&&(temp=="")) temp="I";
	if ((a==1)&&(e==0)&&(i==1)&&(temp=="")) temp="E";
	if ((a==0)&&(e==1)&&(i==1)&&(temp=="")) temp="A";
	if ((b==1)&&(e==1)&&(h==0)&&(temp=="")) temp="H";
	if ((b==1)&&(e==0)&&(h==1)&&(temp=="")) temp="E";
	if ((b==0)&&(e==1)&&(h==1)&&(temp=="")) temp="B";
	if ((d==1)&&(e==1)&&(f==0)&&(temp=="")) temp="F";
	if ((d==1)&&(e==0)&&(f==1)&&(temp=="")) temp="E";
	if ((d==0)&&(e==1)&&(f==1)&&(temp=="")) temp="D";
	if ((g==1)&&(h==1)&&(i==0)&&(temp=="")) temp="I";
	if ((g==1)&&(h==0)&&(i==1)&&(temp=="")) temp="H";
	if ((g==0)&&(h==1)&&(i==1)&&(temp=="")) temp="G";
	if ((c==1)&&(f==1)&&(i==0)&&(temp=="")) temp="I";
	if ((c==1)&&(f==0)&&(i==1)&&(temp=="")) temp="F";
	if ((c==0)&&(f==1)&&(i==1)&&(temp=="")) temp="C";
	if ((g==1)&&(e==1)&&(c==0)&&(temp=="")) temp="C";
	if ((g==1)&&(e==0)&&(c==1)&&(temp=="")) temp="E";
	if ((g==0)&&(e==1)&&(c==1)&&(temp=="")) temp="G";
	
	if ((f==1)&&(h==1)&&(i==0)&&(temp=="")) temp="I";
	if ((d==1)&&(h==1)&&(g==0)&&(temp=="")) temp="G";
	if ((d==1)&&(b==1)&&(a==0)&&(temp=="")) temp="A";
	if ((f==1)&&(b==1)&&(c==0)&&(temp=="")) temp="C";
}

function logicThree() 
{
	//If no suitable move was found, do a random move
	if((e==0) &&(temp==""))temp="E";
	if((a==0) &&(temp==""))temp="A";
	if((i==0) &&(temp==""))temp="I";
	if((c==0) &&(temp==""))temp="C";
	if((g==0) &&(temp==""))temp="G";
	if((b==0) &&(temp==""))temp="B";
	if((h==0) &&(temp==""))temp="H";
	if((d==0) &&(temp==""))temp="D";
	if((f==0) &&(temp==""))temp="F";
}

function getMoveLetter(moveValue)
{
	switch(moveValue)
	{
	case 1:
	  return 'A';
	  break;
	case 2:
	  return 'B';
	  break;
	case 3:
	  return 'C';
	  break;
	case 4:
	  return 'D';
	  break;
	case 5:
	  return 'E';
	  break;
	case 6:
	  return 'F';
	  break;
	case 7:
	  return 'G';
	  break;
	case 8:
	  return 'H';
	  break;
	case 9:
	  return 'I';
	  break;
	}
}

function alertWinner()
{
	//if winner == 1, player X won. If winner == 2, player O won. if winner == 3, game was tied
	if(winner==1)
	{
		alert("You beat the unbeatable Tic Tac Toe game! Impressive!");
		document.getElementById("infomessages").innerHTML = "You beat the unbeatable Tic Tac Toe game! Impressive!";
	}
	else if(winner==2)
	{
		alert("You lost the game!");
		document.getElementById("infomessages").innerHTML = "You lost the game!";
	}
	else
	{
		alert("Tie game! Keep trying!");
		document.getElementById("infomessages").innerHTML = "Tie game! Keep trying!";
	}
	gameover = true;
	gameInProgress = false;
}

function markPieceTaken(piece)
{
	if(piece=='A')
	{
		if(myturn)
		{
			a=1;
		}
		else
		{
			a=2;
		}
	}
	else if(piece=='B')
	{
		if(myturn)
		{
			b=1;
		}
		else
		{
			b=2;
		}
	}
	else if(piece=='C')
	{
		if(myturn)
		{
			c=1;
		}
		else
		{
			c=2;
		}
	}
	else if(piece=='D')
	{
		if(myturn)
		{
			d=1;
		}
		else
		{
			d=2;
		}
	}
	else if(piece=='E')
	{
		if(myturn)
		{
			e=1;
		}
		else
		{
			e=2;
		}
	}
	else if(piece=='F')
	{
		if(myturn)
		{
			f=1;
		}
		else
		{
			f=2;
		}
	}
	else if(piece=='G')
	{
		if(myturn)
		{
			g=1;
		}
		else
		{
			g=2;
		}
	}
	else if(piece=='H')
	{
		if(myturn)
		{
			h=1;
		}
		else
		{
			h=2;
		}
	}
	else if(piece=='I')
	{
		if(myturn)
		{
			i=1;
		}
		else
		{
			i=2;
		}
	}
}

function checkWinner()
{
	//if winner == 1, player X won. If winner == 2, player O won. if winner == 3, game was tied
	if ((a==1)&&(b==1)&&(c==1)) winner=1;
	if ((a==1)&&(d==1)&&(g==1)) winner=1;
	if ((a==1)&&(e==1)&&(i==1)) winner=1;
	if ((b==1)&&(e==1)&&(h==1)) winner=1;
	if ((d==1)&&(e==1)&&(f==1)) winner=1;
	if ((g==1)&&(h==1)&&(i==1)) winner=1;
	if ((c==1)&&(f==1)&&(i==1)) winner=1;
	if ((g==1)&&(e==1)&&(c==1)) winner=1;
	if ((a==2)&&(b==2)&&(c==2)) winner=2;
	if ((a==2)&&(d==2)&&(g==2)) winner=2;
	if ((a==2)&&(e==2)&&(i==2)) winner=2;
	if ((b==2)&&(e==2)&&(h==2)) winner=2;
	if ((d==2)&&(e==2)&&(f==2)) winner=2;
	if ((g==2)&&(h==2)&&(i==2)) winner=2;
	if ((c==2)&&(f==2)&&(i==2)) winner=2;
	if ((g==2)&&(e==2)&&(c==2)) winner=2;
	if ((a != 0)&&(b != 0)&&(c != 0)&&(d != 0)&&(e != 0)&&(f != 0)&&(g != 0)&&(h != 0)&&(i != 0)&&(winner == 0)) winner = 3;
}

function checkPiecePlayer(piece)
{
	if(document.images[piece].src.indexOf("x.jpg")!=-1)
	{
		return "x";
	}
	if(document.images[piece].src.indexOf("o.jpg")!=-1)
	{
		return "o";
	}
	if(document.images[piece].src.indexOf("blank.jpg")!=-1)
	{
		return "blank";
	}
}

function checkSpace(piece)
{
	if(document.images[piece].src.indexOf("blank.jpg")==-1)
	{
		return false;
	}
	else
	{
		return true;
	}
}

